// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, IssueSeverity};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsValidatorIssue")]
    pub struct ValidatorIssue(Object<ffi::AsValidatorIssue, ffi::AsValidatorIssueClass>);

    match fn {
        type_ => || ffi::as_validator_issue_get_type(),
    }
}

impl ValidatorIssue {
    pub const NONE: Option<&'static ValidatorIssue> = None;

    #[doc(alias = "as_validator_issue_new")]
    pub fn new() -> ValidatorIssue {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_validator_issue_new()) }
    }
}

impl Default for ValidatorIssue {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ValidatorIssue>> Sealed for T {}
}

pub trait ValidatorIssueExt: IsA<ValidatorIssue> + sealed::Sealed + 'static {
    #[doc(alias = "as_validator_issue_get_cid")]
    #[doc(alias = "get_cid")]
    fn cid(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_validator_issue_get_cid(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_validator_issue_get_explanation")]
    #[doc(alias = "get_explanation")]
    fn explanation(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_validator_issue_get_explanation(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_validator_issue_get_filename")]
    #[doc(alias = "get_filename")]
    fn filename(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_validator_issue_get_filename(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_validator_issue_get_hint")]
    #[doc(alias = "get_hint")]
    fn hint(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_validator_issue_get_hint(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_validator_issue_get_line")]
    #[doc(alias = "get_line")]
    fn line(&self) -> libc::c_long {
        unsafe { ffi::as_validator_issue_get_line(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_validator_issue_get_location")]
    #[doc(alias = "get_location")]
    fn location(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_full(ffi::as_validator_issue_get_location(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_validator_issue_get_severity")]
    #[doc(alias = "get_severity")]
    fn severity(&self) -> IssueSeverity {
        unsafe {
            from_glib(ffi::as_validator_issue_get_severity(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_validator_issue_get_tag")]
    #[doc(alias = "get_tag")]
    fn tag(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_validator_issue_get_tag(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_validator_issue_set_cid")]
    fn set_cid(&self, cid: &str) {
        unsafe {
            ffi::as_validator_issue_set_cid(self.as_ref().to_glib_none().0, cid.to_glib_none().0);
        }
    }

    #[doc(alias = "as_validator_issue_set_explanation")]
    fn set_explanation(&self, explanation: &str) {
        unsafe {
            ffi::as_validator_issue_set_explanation(
                self.as_ref().to_glib_none().0,
                explanation.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_validator_issue_set_filename")]
    fn set_filename(&self, fname: &str) {
        unsafe {
            ffi::as_validator_issue_set_filename(
                self.as_ref().to_glib_none().0,
                fname.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_validator_issue_set_hint")]
    fn set_hint(&self, hint: &str) {
        unsafe {
            ffi::as_validator_issue_set_hint(self.as_ref().to_glib_none().0, hint.to_glib_none().0);
        }
    }

    #[doc(alias = "as_validator_issue_set_line")]
    fn set_line(&self, line: libc::c_long) {
        unsafe {
            ffi::as_validator_issue_set_line(self.as_ref().to_glib_none().0, line);
        }
    }

    #[doc(alias = "as_validator_issue_set_severity")]
    fn set_severity(&self, severity: IssueSeverity) {
        unsafe {
            ffi::as_validator_issue_set_severity(
                self.as_ref().to_glib_none().0,
                severity.into_glib(),
            );
        }
    }

    #[doc(alias = "as_validator_issue_set_tag")]
    fn set_tag(&self, tag: &str) {
        unsafe {
            ffi::as_validator_issue_set_tag(self.as_ref().to_glib_none().0, tag.to_glib_none().0);
        }
    }
}

impl<O: IsA<ValidatorIssue>> ValidatorIssueExt for O {}
